Index: external/fastjet/contribs/Nsubjettiness/AUTHORS
===================================================================
--- external/fastjet/contribs/Nsubjettiness/AUTHORS	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/contribs/Nsubjettiness/AUTHORS	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -1,12 +1,16 @@
-The Nsubjettiness FastJet contrib was written and is maintained and developed by:
+-------------------------------------------------------------------------------
 
-   Jesse Thaler <jthaler@jthaler.net>
+The Nsubjettiness FastJet contrib was written, maintained, and developed by:
+
+   Jesse Thaler <jthaler@mit.edu>
    Ken Van Tilburg <kenvt@stanford.edu>
    Christopher K. Vermilion <christopher.vermilion@gmail.com>
    TJ Wilkason <tjwilk@mit.edu>
 
-Questions and comments should be directed to:  jthaler@jthaler.net.
+Questions and comments should be directed to:  jthaler@mit.edu.
 
-For physics details, see:
+-------------------------------------------------------------------------------
+
+For physics details on N-subjettiness, see:
 
    Identifying Boosted Objects with N-subjettiness.
@@ -20,9 +24,24 @@
 New in v2.0 is the winner-take-all axis, described in:
 
+   Jet Observables Without Jet Algorithms. 
+   Daniele Bertolini, Tucker Chan, and Jesse Thaler. 
+   JHEP 1404:013 (2014), arXiv:1310.7584.
+
    Jet Shapes with the Broadening Axis. 
    Andrew J. Larkoski, Duff Neill, and Jesse Thaler. 
    JHEP 1404:017 (2014), arXiv:1401.2158.
 
-as well as in unpublished work by Gavin Salam.
+   Unpublished work by Gavin Salam.
 
-----------------------------------------------------------------------
+New in v2.2 is the XCone jet algorithm, described in:
+
+   XCone: N-jettiness as an Exclusive Cone Jet Algorithm.
+   Iain W. Stewart, Frank J. Tackmann, Jesse Thaler,
+   Christopher K. Vermilion, and Thomas F. Wilkason.
+   arXiv:1508.01516.
+
+   Resolving Boosted Jets with XCone.
+   Jesse Thaler and Thomas F. Wilkason.
+   arXiv:1508.01518.
+
+-------------------------------------------------------------------------------
Index: external/fastjet/contribs/Nsubjettiness/AxesDefinition.cc
===================================================================
--- external/fastjet/contribs/Nsubjettiness/AxesDefinition.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
+++ external/fastjet/contribs/Nsubjettiness/AxesDefinition.cc	(revision 8713dee253b44fe1d26e1aad36beeb66152508c4)
@@ -0,0 +1,95 @@
+//  Nsubjettiness Package
+//  Questions/Comments?  jthaler@jthaler.net
+//
+//  Copyright (c) 2011-14
+//  Jesse Thaler, Ken Van Tilburg, Christopher K. Vermilion, and TJ Wilkason
+//
+//  $Id: AxesDefinition.cc 833 2015-07-23 14:35:23Z jthaler $
+//----------------------------------------------------------------------
+// This file is part of FastJet contrib.
+//
+// It is free software; you can redistribute it and/or modify it under
+// the terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 2 of the License, or (at
+// your option) any later version.
+//
+// It is distributed in the hope that it will be useful, but WITHOUT
+// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+// License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this code. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+
+#include "AxesDefinition.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+namespace contrib {
+  
+// Repeatedly calls the one pass finder to try to find global minimum
+std::vector<fastjet::PseudoJet> AxesDefinition::get_multi_pass_axes(int n_jets,
+                                                                    const std::vector <fastjet::PseudoJet> & inputJets,
+                                                                    const std::vector <fastjet::PseudoJet> & seedAxes,
+                                                                    const MeasureDefinition* measure) const {
+   
+   assert(n_jets == (int)seedAxes.size()); //added int casting to get rid of compiler warning
+   
+   // first iteration
+   std::vector<fastjet::PseudoJet> bestAxes = measure->get_one_pass_axes(n_jets, inputJets, seedAxes,_nAttempts,_accuracy);
+   
+   double bestTau = measure->result(inputJets,bestAxes);
+   
+   for (int l = 1; l < _Npass; l++) { // Do minimization procedure multiple times (l = 1 to start since first iteration is done already)
+      
+      // Add noise to current best axes
+      std::vector< PseudoJet > noiseAxes(n_jets, PseudoJet(0,0,0,0));
+      for (int k = 0; k < n_jets; k++) {
+         noiseAxes[k] = jiggle(bestAxes[k]);
+      }
+      
+      std::vector<fastjet::PseudoJet> testAxes = measure->get_one_pass_axes(n_jets, inputJets, noiseAxes,_nAttempts,_accuracy);
+      double testTau = measure->result(inputJets,testAxes);
+      
+      if (testTau < bestTau) {
+         bestTau = testTau;
+         bestAxes = testAxes;
+      }
+   }
+   
+   return bestAxes;
+}
+
+   
+// Used by multi-pass minimization to jiggle axes with noise range.
+PseudoJet AxesDefinition::jiggle(const PseudoJet& axis) const {
+   double phi_noise = ((double)rand()/(double)RAND_MAX) * _noise_range * 2.0 - _noise_range;
+   double rap_noise = ((double)rand()/(double)RAND_MAX) * _noise_range * 2.0 - _noise_range;
+   
+   double new_phi = axis.phi() + phi_noise;
+   if (new_phi >= 2.0*M_PI) new_phi -= 2.0*M_PI;
+   if (new_phi <= -2.0*M_PI) new_phi += 2.0*M_PI;
+   
+   PseudoJet newAxis(0,0,0,0);
+   newAxis.reset_PtYPhiM(axis.perp(),axis.rap() + rap_noise,new_phi);
+   return newAxis;
+}
+
+   
+LimitedWarning HardestJetAxes::_too_few_axes_warning;
+LimitedWarning ExclusiveJetAxes::_too_few_axes_warning;
+LimitedWarning ExclusiveCombinatorialJetAxes::_too_few_axes_warning;
+
+std::vector<fastjet::PseudoJet> Manual_Axes::get_starting_axes(int,
+                                                               const std::vector<fastjet::PseudoJet>&,
+                                                               const MeasureDefinition *) const {
+   // This is a function dummy and should never be called
+   assert(false);
+   std::vector<fastjet::PseudoJet> dummy;
+   return dummy;
+}
+
+} // namespace contrib
+
+FASTJET_END_NAMESPACE
